var _path = '/17PDF';
var _pendingReloads = [];
var _reloadingDisabled = 0;

function formatFileSize(bytes) {
  if (bytes >= 1000000000) {
    return (bytes / 1000000000).toFixed(2) + ' G';
  }
  if (bytes >= 1000000) {
    return (bytes / 1000000).toFixed(2) + ' M';
  }
  return (bytes / 1000).toFixed(2) + ' K';
}

function _disableReloads() {
  _reloadingDisabled += 1;
}

function _enableReloads() {
  _reloadingDisabled -= 1;
  
  if (_pendingReloads.length > 0) {
    _reload(_pendingReloads.shift());
  }
}

function _reload(path) {
  if (_reloadingDisabled) {
    if ($.inArray(path, _pendingReloads) < 0) {
      _pendingReloads.push(path);
    }
    return;
  }
  _disableReloads();
  $.ajax({
    url: '/filelist',
    type: 'GET',
    data: {dir: path},
    dataType: 'json'
  }).fail(function(jqXHR, textStatus, errorThrown) {
  }).done(function(data, textStatus, jqXHR) {
    $('.empty-status').hide();
    var scrollPosition = $(document).scrollTop();
    
    $(".folder").empty();
    if (path == "/17PDF") {
      $(".folder").append('<span class="active">17PDF</span>');
    } else {
      var components = path.split("/").slice(1);
      for (var i = 0; i < components.length - 1; ++i) {
        var subpath = "/" + components.slice(0, i + 1).join("/");
        $(".folder").append('<span class="folder-item" data-path="' + subpath + '">' + components[i] + '</span><span class="arrow">&nbsp;>&nbsp;</span>');
      }
      $(".folder > .folder-item").click(function(event) {
        _reload($(this).data("path"));
        event.preventDefault();
      });
      $(".folder").append('<span class="active">' + components[components.length - 1] + '</span>');
    }
    _path = data.mCurrentDir;
    $(".listing").empty();
    if (data.mDirInfo.length === 0 && data.mFileInfo.length === 0) {
      $('.empty-status').show();
      return
    }
    for (var i = 0, dir; dir = data.mDirInfo[i]; ++i) {
      $(tmpl("template-listing-dir", dir)).data(dir).appendTo(".listing");
    }
    for (var i = 0, file; file = data.mFileInfo[i]; ++i) {
      file.url = _path === "/" ? _path + encodeURIComponent(file.mName) : _path  + '/' + encodeURIComponent(file.mName);
      var names = file.mName.split('.');
      var name = names[names.length - 1].toLowerCase();
      if (!(/ai|azw3|csv|doc|docx|dps|epub|et|html|jpg|mobi|pdf|png|ppt|pptx|psd|rtf|txt|webp|wps|xls|xlsx|zip/.test(name))) {
        file.format = 'others';
      } else {
        file.format = name;
      }
      $(tmpl("template-listing-file", file)).data(file).appendTo(".listing");
    }
    
    $(".button-open").click(function(event) {
      var name = $(this).data("name");
      var path = _path === '/' ? _path + name : _path + '/' + name;
      _reload(path);
    });
    
    $(document).scrollTop(scrollPosition);
  }).always(function() {
    _enableReloads();
  });
}

$(document).ready(function() {
  var flag = navigator.userAgent.match(/(phone|pad|pod|iPhone|iPod|ios|iPad|Android|Mobile|BlackBerry|IEMobile|MQQBrowser|JUC|Fennec|wOSBrowser|BrowserNG|WebOS|Symbian|Windows Phone)/i);
  if (flag) {
    $('.upload-text .drop-text').hide();
    $('.empty-sub-text-min').show();
    $('.empty-sub-text').hide();
  }
  $('.dropzone').on('dragover', function(e) {
    e.preventDefault();
    var dropZone = $('.dropzone'),
      timeout = window.dropZoneTimeout;
    if (!timeout) {
      $('.dropCover').show();
    } else {
      clearTimeout(timeout);
    }
    var node = e.target;
    do {
      if (node === dropZone[0]) {
        break;
      }
      node = node.parentNode;
    } while (node != null);
    window.dropZoneTimeout = setTimeout(function () {
      window.dropZoneTimeout = null;
      $('.dropCover').hide();
    }, 100);
  })

  $('.dropzone').on('drop', function(e) {
    e.stopPropagation();
    e.preventDefault();
  })
  
  $(".upload-file").click(function(event) {
    $("#fileupload").click();
  });
  
  $("#fileupload").click(function(event) {
    event.stopPropagation();
  });
  
  $("#fileupload").fileupload({
    dropZone: $('.dropzone'),
    pasteZone: null,
    autoUpload: true,
    sequentialUploads: true,
    // limitConcurrentUploads: 2,
    url: '/upload',
    type: 'POST',

    start: function(e) {
      $(".uploading").show();
    },
    
    stop: function(e) {
      if ($('.uploading .uploading-list').children().length > 0) return
      $(".uploading").hide();
    },

    add: function(e, data) {
      var file = data.files[0];
      var names = file.name.split('.')
      var name = names[names.length - 1].toLowerCase()
      if (!(/pdf|doc|docx|epub|pptx|ppt|rtf|xlsx|xls|mobi|azw3|psd|ai|wps|dps|et|txt|jpg|png|csv|html|webp/.test(name))) return
      data.context = $(tmpl("template-uploads", {
        name: file.name
      })).appendTo(".uploading .uploading-list");
      var jqXHR = data.submit();
      data.context.find(".btn").click(function(event) {
        jqXHR.abort();
        data.context.remove();
        if ($('.uploading .uploading-list').children().length > 0) return
        $(".uploading").hide();
      });
    },

    progress: function(e, data) {
      var progress = parseInt(data.loaded / data.total * 100, 10);
      data.context.find('.wait').removeClass('wait')
      data.context.find('.wait-text').hide()
      data.context.find(".progress-bar").css("width", progress + "%");
      data.context.find(".progress-num").text(progress + "%")

    },

    done: function(e, data) {
      _reload(_path);
      data.context.remove();
    },

    fail: function(e, data) {
      if (data.errorThrown != "abort") {
        data.context.find(".file-info .progress").hide();
        data.context.find(".file-info .progress-num").hide();
        data.context.find(".wait-text").html('<img src="new_17_pdf/img/file_ic_error.png" alt=""><span class="error">上传失败</span>').show();
      }
    },
    
  });
  
  $.ajax({
    methods: 'GET',
    url: '/device',
    dataType: 'json',
  }).fail(function(jqXHR, textStatus, errorThrown) {
    $('.device').hide();
  }).done(function(data, textStatus, jqXHR) {
    $('.device .name').text(data.mDeviceName)
  })

  _reload("/17PDF");
  
});
